<?php
/*
Plugin Name: Cookie Control
Plugin URI: http://www.sherred.com/plugins/cookiecontrol/
Description: This plugin enables you to comply with UK and EU law on cookies. Wordpress plugin by sherred, JavaScript by Civic UK
Version: 0.1
Author: @sherred and Civic UK
Author URI: http://civicuk.com/cookie-law/index
*/

//  defaults
$def_cookiecontrol_text = 'This site uses cookies to store information on your computer. Some of these cookies are essential to make our site work and others help us to improve by giving us some insight into how the site is being used.';
$def_cookiecontrol_position = 'left';
$def_cookiecontrol_shape = 'triangle';
$def_cookiecontrol_startopen = TRUE;
$def_cookiecontrol_timeout = '60';
$def_cookiecontrol_countries = '';
$def_cookiecontrol_privacypage = '';
$def_cookiecontrol_onready = '';
$def_cookiecontrol_onaccept = '';
$def_cookiecontrol_cookiesallowed = '';
$def_cookiecontrol_cookiesnotallowed = '';

//	define defaults
$cookiecontrol_defaults = apply_filters('cookiecontrol_defaults', array(
	'text' => $def_cookiecontrol_text,
	'position' => $def_cookiecontrol_position,
	'shape' => $def_cookiecontrol_shape,
	'startopen' => $def_cookiecontrol_startopen,
	'timeout' => $def_cookiecontrol_timeout,
	'countries' => $def_cookiecontrol_countries,
	'privacypage' => $def_cookiecontrol_privacypage,
	'onready' => $def_cookiecontrol_onready,
	'onaccept' => $def_cookiecontrol_onaccept,
	'cookiesallowed' => $def_cookiecontrol_cookiesallowed,
	'cookiesnotallowed' => $def_cookiecontrol_cookiesnotallowed,
));

//	pull the settings from the db
$cookiecontrol_settings = get_option('cookiecontrol_settings');

//	fallback
$cookiecontrol_settings = wp_parse_args($cookiecontrol_settings, $cookiecontrol_defaults);

//	registers settings in the db
add_action('admin_init', 'cookiecontrol_register_settings');
function cookiecontrol_register_settings() {
	register_setting('cookiecontrol_settings', 'cookiecontrol_settings', 'cookiecontrol_settings_validate');
}
//	this function adds the settings page to the Appearance tab
add_action('admin_menu', 'add_cookiecontrol_menu');
function add_cookiecontrol_menu() {
	add_menu_page('Cookie Control', 'Cookie Control', 'administrator', 'cookiecontrol', 'cookiecontrol_admin_page');
}

function cookiecontrol_admin_page() { 
?>
	<h2>Cookie Control Seetings</h2>
	<div class="wrap">
	<?php cookiecontrol_settings_update_check(); ?>
	<form method="post" action="options.php">
	<?php settings_fields('cookiecontrol_settings'); ?>
	<?php global $cookiecontrol_settings; $options = $cookiecontrol_settings; ?>
	<table class="form-table">

		<tr valign="top"><th scope="row"><label for="cookiecontrol_settings[text]">Explanation Text</label></th>
		<td>A short message about the use of cookies on this site.<br />
		<textarea name="cookiecontrol_settings[text]" id="cookiecontrol_settings[text]" cols="50" rows="5"><?php echo $options['text'] ?></textarea>
		</td>
		</tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[privacypage]">Privacy Page</label></th>
		<td>Specify the URL site's privacy policy:<br />
			<input type="text" name="cookiecontrol_settings[privacypage]" id="cookiecontrol_settings[privacypage]" value="<?php echo $options['privacypage'] ?>" />
		</td></tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[shape]">Icon Shape</label></th>
		<td>The icon will be anchored to the corner of the viewport and won't scroll with your web page.<br />
			<input type="radio" name="cookiecontrol_settings[shape]" id="cookiecontrol_settings[shape]" value="triangle" <?php checked('triangle', $options['shape']); ?> /> Triangle
			<input type="radio" name="cookiecontrol_settings[shape]" id="cookiecontrol_settings[shape]" value="diamond" <?php checked('diamond', $options['shape']); ?> /> Diamond
		</td></tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[position]">Icon Position</label></th>
		<td>Choose whether you'd like your icon to appear on the bottom left or bottom right of the browser window.<br />
			<input type="radio" name="cookiecontrol_settings[position]" id="cookiecontrol_settings[position]" value="left" <?php checked('left', $options['position']); ?> /> Left
			<input type="radio" name="cookiecontrol_settings[position]" id="cookiecontrol_settings[position]" value="bottom" <?php checked('bottom', $options['position']); ?> /> Bottom
		</td></tr>
		
		<tr valign="top"><th scope="row">Open the cookie information on page load.</th>
		<td>Visitors to the site will see the pop-up at the bottom of their browser on every page load until they acknowledge the pop-up.<br />
		<input name="cookiecontrol_settings[startopen]" type="checkbox" value="TRUE" <?php checked("TRUE", $options['startopen']); ?> /> <label for="cookiecontrol_settings[startopen]"></td>
		</tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[timeout]">Automatic Hide Timeout</label></th>
		<td>How long to keep the information pop-up displayed before it is automatically hidden. Once hidden the information can be accessed by clicking on the icon in the corner.<br />
			<input type="text" name="cookiecontrol_settings[timeout]" id="cookiecontrol_settings[timeout]" value="<?php echo $options['timeout'] ?>" size="4" />
		</td></tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[countries]">Country Restriction</label></th>
		<td>Enter a comma separated list of countries for which you wish the pop-up to appear. If left blank Cookie Control will appear for all users from all countries. The full list of countries can be found <a href="http://www.geoplugin.com/iso3166">here</a>.<br />
			<input type="text" name="cookiecontrol_settings[countries]" id="cookiecontrol_settings[countries]" value="<?php echo $options['countries'] ?>" />
		</td></tr>
		
		<input type="hidden" name="cookiecontrol_settings[update]" value="UPDATED" />
	
	</table>
	<h3>Advanced Settings</h3>
	<p>Only set these if you know JavaScript or your developer has told you what to enter. For further information on these options, please visit <a href="http://civicuk.com/cookie-law/deployment#callbacks">Cookie Control Deployment</a></p>
	<table class="form-table">
		<tr valign="top"><th scope="row"><label for="cookiecontrol_settings[onaccept]">On Accept</label></th>
		<td>This callback runs ONCE, the FIRST time a user consents to cookies:<br />
			<input type="text" name="cookiecontrol_settings[onaccept]" id="cookiecontrol_settings[onaccept]" value="<?php echo $options['onaccept'] ?>" />
		</td></tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[onready]">On Ready</label></th>
		<td>This callback runs immediately after CookieControl has initialised and displayed its widget, if applicable:<br />
			<input type="text" name="cookiecontrol_settings[onready]" id="cookiecontrol_settings[onready]" value="<?php echo $options['onready'] ?>" />
		</td></tr>
		
		<tr valign="top"><th scope="row"><label for="cookiecontrol_settings[cookiesallowed]">Cookies Allowed</label></th>
		<td>This callback runs after CookieControl has initialised, if cookies are allowed:<br />
			<input type="text" name="cookiecontrol_settings[cookiesallowed]" id="cookiecontrol_settings[cookiesallowed]" value="<?php echo $options['cookiesallowed'] ?>" />
		</td></tr>
		
		<tr><th scope="row"><label for="cookiecontrol_settings[cookiesnotallowed]">Cookies Not Allowed</label></th>
		<td>This callback runs after CookieControl has initialised, if cookies are NOT (yet) allowed:<br />
			<input type="text" name="cookiecontrol_settings[cookiesnotallowed]" id="cookiecontrol_settings[cookiesnotallowed]" value="<?php echo $options['cookiesnotallowed'] ?>" />
		</td></tr>
	</table>
	<p class="submit">
	<input type="submit" class="button-primary" value="<?php _e('Save Settings') ?>" />
	</form>
	
	<!-- The Reset Option -->
	<form method="post" action="options.php">
	<?php settings_fields('cookiecontrol_settings'); ?>
	<?php global $cookiecontrol_defaults; // use the defaults ?>
	<?php foreach((array)$cookiecontrol_defaults as $key => $value) : ?>
	<input type="hidden" name="cookiecontrol_settings[<?php echo $key; ?>]" value="<?php echo $value; ?>" />
	<?php endforeach; ?>
	<input type="hidden" name="cookiecontrol_settings[update]" value="RESET" />
	<input type="submit" class="button" value="<?php _e('Reset Settings') ?>" />
	</form>
	<!-- End Reset Option -->
	</p>	

	</div>
<?php 
}

function cookiecontrol_settings_update_check() {
	global $cookiecontrol_settings;
	if(isset($cookiecontrol_settings['update'])) {
		echo '<div class="updated fade" id="message"><p>Cookie Control Settings <strong>'.$cookiecontrol_settings['update'].'</strong></p></div>';
		unset($cookiecontrol_settings['update']);
		update_option('cookiecontrol_settings', $cookiecontrol_settings);
	}
}

function cookiecontrol_settings_validate($input) {
	$input['text'] = sanitize_text_field(wp_filter_nohtml_kses($input['text']));
	$input['position'] = wp_filter_nohtml_kses($input['position']);
	$input['shape'] = wp_filter_nohtml_kses($input['shape']);
	$input['timeout'] = intval($input['timeout']);
	$input['countries'] = wp_filter_nohtml_kses($input['countries']);
	
	return $input;
}

add_action('wp_print_scripts', 'cookiecontrol_scripts');
function cookiecontrol_scripts() {
	if(!is_admin()) {
		wp_enqueue_script('cookiecontrol_geo', 'http://www.geoplugin.net/javascript.gp', '', '', true);
		wp_enqueue_script('cookiecontrol', WP_CONTENT_URL.'/plugins/wp_cookiecontrol/js/cookieControl-3.0.1.min.js', array('jquery'), '', true);
	}
}

add_action('wp_footer', 'cookiecontrol_args', 1500);
function cookiecontrol_args() {
	global $cookiecontrol_settings; 
	$cookiecontrol_startopen = ($cookiecontrol_settings['startopen'] == "TRUE") ? 'true' : 'false';
  	$cookiecontrol_timeout = $cookiecontrol_settings['timeout'] * 1000; // Convert seconds to microseconds
  	$privacy = ($cookiecontrol_settings['privacypage'] != '')?sanitize_text_field($cookiecontrol_settings['privacypage']):'';
	?>
<script type="text/javascript">
jQuery(document).ready(function() {
	cookieControl({
      text:"<p><?php echo sanitize_text_field($cookiecontrol_settings['text']); ?></p><p><a href='<?php echo $privacy; ?>'>Privacy Policy</a></p>",
      position:'<?php echo $cookiecontrol_settings['position']; ?>',
      shape:'<?php echo $cookiecontrol_settings['shape']; ?>',
      startOpen:<?php echo $cookiecontrol_startopen; ?>,
      autoHide:<?php echo $cookiecontrol_timeout; ?>,
      onAccept:function(){<?php echo $cookiecontrol_settings['onaccept']; ?>},
      onReady:function(){<?php echo $cookiecontrol_settings['onready']; ?>},
      onCookiesAllowed:function(){<?php echo $cookiecontrol_settings['cookiesallowed']; ?>},
      onCookiesNotAllowed:function(){<?php echo $cookiecontrol_settings['cookiesnotallowed']; ?>},
      countries:'<?php echo $cookiecontrol_settings['countries']; ?>'
      });
});
</script>
<?php }
